

ircd_running () {
	if test -r $pidfile
	then
		ircupid=`cat $pidfile`
		runcnt=`ps x|grep ircd|grep $ircupid|grep -v grep|wc -l`
		if [ $runcnt == 1 ]
		then 
			return 0 
		else
			return 1 
	    	fi
	else
		return 1 
	fi
}


# Check if the ircu binary exists
if ! [ -x $binfile ]
then
	echo "Error: $binfile does not exist or is not the executable"
	exit 0
fi

case "$1" in
    start)
    		if ! ircd_running
		then
			echo -n "Starting ircu ..."
			$binfile
			sleep 2
			if ! ircd_running
			then
				echo " Failed."
				echo " The ircu server did NOT start for some reason. Please examine your configuration."
			else
				echo " Done. (pid $ircupid)"
			fi
		else
			echo "ircu already running at pid $ircupid"
		fi
		;;
     stop)
     		if ircd_running; then
			echo -n "Killing ircu daemon (pid $ircupid) with signal 9 (die) ..."
			kill -9 $ircupid
			sleep 2
			if ircd_running
			then
				echo " Failed."
				echo " The ircu is still running. Possible high load."
			else
				echo " Done"
			fi
		else
			echo "ircu not running"
		fi
		;;
   rehash)	
   		if ircd_running; then
			echo -n "Killing ircu daemon (pid $ircupid) with signal 1 (rehash) ..."
			kill -1 $ircupid
			sleep 2
			if ! ircd_running
			then
				echo " Failed."
				echo " The ircu crashed on rehash. Please examine your configuration."
			else
				echo " Done (pid $ircupid)"
			fi
		else
			echo "ircu not running"
		fi
		;;
  restart)
  		if ircd_running; then
			echo -n "Killing ircu daemon (pid $ircupid) with signal 2 (restart) ..."
			kill -2 $ircupid
			sleep 2
			if ! ircd_running
			then
				echo " Failed."
				echo " The ircu crashed on rehash. Please examine your configuration."
			else
			        echo " Done (pid $ircupid)"
			fi
		else
			echo -n "Starting ircu ..."
			$binfile
			sleep 2
			if ! ircd_running
			then
				echo " Failed."
				echo " The ircu server did NOT start for some reason. Please examine your configuration."
			else
				echo " Done. (pid $ircupid)"
			fi
		fi
		;;
force-restart)
		$0 stop
		$0 start
		;;
    check)
    		if ircd_running; then
			echo "ircu is running at pid `cat $pidfile`"
		else
			echo "ircu is NOT running"
			rm -f $pidfile
		fi
		;;
        *)
		echo "Usage: $0 {start|stop|rehash|restart|force-restart|check}"
		exit 1
		;;
esac

exit 0


